Description

Returning Error objects
The TYPO3\FLOW3\Property\TypeConverter\DateTimeConverter should return an \TYPO3\FLOW3\Error\Error instead of
throwing an \TYPO3\FLOW3\Property\Exception\TypeConverterException.

The advantage of this change is the much better handling of form convertion/validation error messages. The messages are stored as
"validationResults" in $this->arguments of the current ActionController.

Displaying the messages could be easily done with the Fluid ViewHelper f:form.validationResults.

Support "empty" DateTime -> Convert to NULL
Right now, the DateTimeConverter is required, i.e. it is not possible to define an optional DateTime object.

When the DateTime converter returns NULL for the empty string, one can use "@validate NotEmpty" for required properties.

Associated revisions
Revision b47d1c61 - 2011-09-07 14:34 - Sebastian Kurfuerst

[!!!][BUGFIX] DateTimeConverter returns Errors instead of throwing exceptions

As described in the Property Mapper reference manual, DateTimeConverter should
only throw exceptions when detecting developer failures. If user failures
happen, such as invalid input, an \TYPO3\FLOW3\Error\Error object should instead
be returned, as this is shown to the end-user in a friendly way, and the original
form is redisplayed.

Furthermore, DateTimeConverter must convert an empty date string ('') to NULL;
else it is not possible to define optional DateTime properties.

If you need a required DateTime property, use the @validate NotEmpty annotation
in your model.

Change-Id: Ie95602c44e9d86586353514cbde2cd06259f3b30
Resolves: #27806

History
#1 - 2011-07-04 09:27 - Robert Lemke
- Category set to Property
- Assigned To set to Sebastian Kurfuerst
- Target version set to 1230

#2 - 2011-09-06 09:34 - Sebastian Kurfuerst
- Status changed from New to Accepted
- Target version changed from 1230 to 1.0 beta 2

#3 - 2011-09-06 09:37 - Sebastian Kurfuerst
- Subject changed from DateTimeConverter should return an Error instead of throwing Exceptions to DateTimeConverter should return Error objects 
for user-errors; and support converting an empty string to NULL

Hey Michael,

sorry for hijacking the description; I extended it a bit - and will work on a fix now.

Greets,
Sebastian

#4 - 2011-09-06 09:41 - Mr. Hudson
- Status changed from Accepted to Under Review

Patch set 1 of change Ie95602c44e9d86586353514cbde2cd06259f3b30 has been pushed to the review server.
It is available at http://review.typo3.org/4786

#5 - 2011-09-07 14:36 - Mr. Hudson

Patch set 2 of change Ie95602c44e9d86586353514cbde2cd06259f3b30 has been pushed to the review server.
It is available at http://review.typo3.org/4786

#6 - 2011-09-07 15:06 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:b47d1c61aaaf67c6d9c3379d87fe132ff7bded80.
